--=======================================================================--
--===========================  st_FindPhone   ===========================--
--=======================================================================--


createState( "st_FindPhone" )
st_FindPhone:useLayers( backgroundLayers,
						"ui_FindPhone" )
		


function st_FindPhone.init()
	txtTitle:SET( m_i18n("Phone") )
	MODEL.lua.easyShowDoneKey = true
	MODEL.regional.keyboard.load_panel_by_type( EInputPanelType.Numeric )
	MODEL.regional.keyboard.modifiers = 0
	inp_Phone:SYNCKBPANEL()
	if #ui.inp_Phone.VALUE() == 0 then
		kbn_5_5_num_done:ENABLE(false)
	end
	
	inp_Phone:EMPTYTITLE( "<Enter a Phone Number>" ) 
	
	local enabledKeys = L"0123456789"
	
	MODEL.lua.filterTravelInputKeys = enabledKeys
	MODEL.regional.keyboard.smartkey_model("lua.filterTravelInputKeys")
	
	vKeyTableDone:SET( sc_SearchPhoneNumber )
end

function st_FindPhone.exit()
	inp_Phone:VALUE(L"")
end

function sc_SearchPhoneNumber()
	MODEL.poi.phone_search.name_filter = L""
	MODEL.poi.phone_search.phone_filter = ui.inp_Phone.VALUE()
	MODEL.poi.phone_search.ext_info_strict = 1 -- no indexing needed
	MODEL.poi.phone_search.execute()
	
	sc_NextStateAnim(st_FindPhoneResults, "horz_scroll", 1, "")
end

-- function sc_CreatePhoneSearch()
	-- MODEL.poi.create_search("phone_search", "flat")
	-- MODEL.poi.phone_search.max_result = 30
-- end

--sc_CreatePhoneSearch()


createState( "st_FindPhoneResults" )
st_FindPhoneResults:useLayers( 	backgroundLayers,
								"ui_FindPhoneResults",
								localMenuLayers,
								"ui_List_Background")


function st_FindPhoneResults.enter()
	--gFlatSearchInQueue = gFlatSearchInQueue + 1
	-- if not gStructSearchFilter_valid then
		-- MODEL.lua.PoiListFilterString = L""
	-- end
	
	if (not MODEL.poi.phone_search.list.isempty()) then
		MODEL.poi.phone_search.ready = false
	end

--	MODEL.lua.poiListNoHighlight = not st_FindPOIFlatList.filter_is_postfilter
end

function st_FindPhoneResults.init()
	txtTitle:SET( m_i18n("Places Found") );
	MODEL.poi.phone_search.resume_search()
	sc_init_local_menu("ui.lm_moremenu_phone_search")
	sc_SetPOISortModel(MODEL.poi.phone_search)
	g_OnPoiListItemClicked = sc_FlatSearch_OnPoiItemClicked
end

function st_FindPhoneResults.done()
	MODEL.poi.phone_search.pause_search()
end

function st_FindPhoneResults.exit()
	--obs_poi_filter_search_done:STOP()
	--obs_poi_filter_struct_search_done:STOP()
	MODEL.lua.PoiListFilterString = L""

	local phone_search = MODEL.poi.phone_search

	-- if(st_FindPOIFlatList.filter_is_postfilter) then
		-- flat_search.remove_from_filter_chain("poi_result", "ext_name_filter")
		-- flat_search.ext_name_filter.name = L""
	-- else
		-- flat_search.name_filter = L""
	-- end
	
	phone_search.drop_result();

	MODEL.lua.poiListNoHighlight = false

	if (not MODEL.poi.phone_search.list.isempty()) then
		MODEL.poi.phone_search.ready = true
	end
	--gFlatSearchInQueue = gFlatSearchInQueue -1
	if gStructSearchInQueue ~= 0 and gStructSearchHasSelectedPOI then
		sc_SelectSavedPOI_Struct()
	end
end

function sc_Inp_Phone_Onchange()
	local inptext = ui.inp_Phone.VALUE()
	kbn_5_5_num_done:ENABLE(#inptext > 6)	
end

function sc_PhoneSearch_ShowOnMap()
	sc_close_local_menu()

	MODEL.poi.resultpoi.clear()
	MODEL.poi.phone_search.fill_resultpoi_provider()
	
	sc_NextStateAnim(st_ShowPoiResultOnMap, "fade")
end

function sc_PhoneSearch_SortByName()
	local phone_search = MODEL.poi.phone_search

	if(phone_search.calculate_detour()) then
		sc_SetPoiSearchMode(phone_search, "multi_sort:igo9_specialpoi_first+multi_sort:name+detour_group")
	else
		sc_SetPoiSearchMode(phone_search, "multi_sort:igo9_specialpoi_first+multi_sort:name+distance")
	end

	sc_close_local_menu()
end

function sc_PhoneSearch_SortByDist()
	local phone_search = MODEL.poi.phone_search

	if(phone_search.calculate_detour() == "forced") then
		sc_SetPoiSearchMode(phone_search, "multi_sort:igo9_specialpoi_first+distance_on_route")
	else
		sc_SetPoiSearchMode(phone_search, "multi_sort:igo9_specialpoi_first+distance")
	end
	
	sc_close_local_menu()
end

function sc_PhoneSearch_SortByDetour()
	sc_SetPoiSearchMode(MODEL.poi.phone_search, "multi_sort:igo9_specialpoi_first+detour_group")
	sc_close_local_menu()
end

-----------------------------------
--Phone
-----------------------------------

function sc_Go_FindPhone()
	local anim = sc_GetFlipAnim(true, SELF.prop.X, SELF.prop.Y, SELF.prop.W, SELF.prop.H)
	sc_NextStateAnim( st_FindPhone, "3d", 0, anim)
end



-----------------------------------
--Phone Search
-----------------------------------

function sc_CreatePhoneSearch()
	MODEL.poi.create_search("phone_search", "flat")
	MODEL.poi.phone_search.max_result = 100
	MODEL.poi.phone_search.center = "gps"
	MODEL.poi.phone_search.area = 1600000
end

sc_CreatePhoneSearch()